commit 76eb842a5f4af738177e8f5d03af810e5cb371f0
Author: Jakub Danek <jakub.danek@yoso.fi>
Date:   Wed Oct 16 22:24:20 2019 +0200

    re #29 crude login page

diff --git a/webapp/src/app/app-routing.module.ts b/webapp/src/app/app-routing.module.ts
index c0e3dd5..a42113e 100644
--- a/webapp/src/app/app-routing.module.ts
+++ b/webapp/src/app/app-routing.module.ts
@@ -5,10 +5,12 @@ import {DashboardComponent} from './dashboard/dashboard.component';
 import {PageNotFoundComponent} from './page-not-found/page-not-found.component';
 import {EmployeeComponentGuard} from './auth/employee-component.guard';
 import {DashboardComponentGuard} from './auth/dashboard-component.guard';
+import {LoginComponent} from "./login/login.component";
 
 const routes: Routes = [
   { path: 'employees', component: EmployeesListComponent, canActivate: [EmployeeComponentGuard], runGuardsAndResolvers: 'always'},
   { path: 'dashboard', component: DashboardComponent, canActivate: [DashboardComponentGuard], runGuardsAndResolvers: 'always'},
+  {path: 'login', component: LoginComponent},
   { path: '', redirectTo: '/dashboard', pathMatch: 'full' },
   { path: '**', component: PageNotFoundComponent }
 ];
diff --git a/webapp/src/app/app.module.ts b/webapp/src/app/app.module.ts
index c5e0d78..5903849 100644
--- a/webapp/src/app/app.module.ts
+++ b/webapp/src/app/app.module.ts
@@ -16,13 +16,15 @@ import {PageNotFoundComponent} from './page-not-found/page-not-found.component';
 import {CommonModule} from '@angular/common';
 
 import {BasicAuthInterceptor} from "./auth/basic-auth.interceptor";
+import {LoginComponent} from "./login/login.component";
 
 @NgModule({
   declarations: [
     AppComponent,
     MenuComponent,
     HeaderComponent,
-    PageNotFoundComponent
+    PageNotFoundComponent,
+    LoginComponent
   ],
   imports: [
     BrowserModule,
diff --git a/webapp/src/app/auth/basic-auth.interceptor.ts b/webapp/src/app/auth/basic-auth.interceptor.ts
index 0ce297e..8e3fce3 100644
--- a/webapp/src/app/auth/basic-auth.interceptor.ts
+++ b/webapp/src/app/auth/basic-auth.interceptor.ts
@@ -2,27 +2,18 @@ import {Injectable} from '@angular/core';
 import {HttpEvent, HttpHandler, HttpInterceptor, HttpRequest} from '@angular/common/http';
 import {Observable} from 'rxjs';
 
-import {ProfileService} from '../services/util/profile.service';
-
 /**
  * Adds authentication token to each request.
  */
 @Injectable()
 export class BasicAuthInterceptor implements HttpInterceptor {
-  constructor(private profileService: ProfileService) {
+  constructor() {
   }
 
   intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>> {
-    // add authorization header with basic auth credentials if available
-    const currentUser = window.btoa(this.profileService.currentUserValue + ":");
-    if (currentUser) {
-      request = request.clone({
-        withCredentials: true,
-        setHeaders: {
-          authorization: `Basic ${currentUser}`
-        }
-      });
-    }
+    request = request.clone({
+      withCredentials: true,
+    });
 
     return next.handle(request);
   }
diff --git a/webapp/src/app/login/login.component.html b/webapp/src/app/login/login.component.html
new file mode 100644
index 0000000..8dbb28a
--- /dev/null
+++ b/webapp/src/app/login/login.component.html
@@ -0,0 +1,9 @@
+<div id="notfound">
+  <div class="notfound">
+    <h1>Sign-in</h1>
+
+    <p>Please sign-in using one of the following methods: </p>
+    <a href="http://localhost:9080/api/signin/google?target=http://localhost">Login with Google</a>
+  </div>
+</div>
+
diff --git a/webapp/src/app/login/login.component.sass b/webapp/src/app/login/login.component.sass
new file mode 100644
index 0000000..e69de29
diff --git a/webapp/src/app/login/login.component.ts b/webapp/src/app/login/login.component.ts
new file mode 100644
index 0000000..52ce458
--- /dev/null
+++ b/webapp/src/app/login/login.component.ts
@@ -0,0 +1,16 @@
+import {Component, OnInit} from '@angular/core';
+
+@Component({
+  selector: 'app-page-not-found',
+  templateUrl: './login.component.html',
+  styleUrls: ['./login.component.sass']
+})
+export class LoginComponent implements OnInit {
+
+  constructor() {
+  }
+
+  ngOnInit() {
+  }
+
+}